#ifndef __headers_h__
#define __headers_h__

struct IpHeader {
  unsigned char		ip_vhl;	/* version (4bits) & header length (4 bits) */
  unsigned char		ip_tos;	/* type of service */
  unsigned short	ip_len; /* length of IP datagram */
  unsigned short	ip_id;	/* identification (for frags) */ 
  unsigned short	ip_off; /* offset (within a fragment) and flags (3 bits) */
  unsigned char		ip_ttl; /* time to live */
  unsigned char		ip_proto;	/* protocol number */
  unsigned short	ip_xsum; /* checksum */
  unsigned int	ip_src; /* source address */
  unsigned int	ip_dst; /* destination address */
};

struct tcpPseudoHdr {
  unsigned int srcip;
  unsigned int dstip;
  unsigned char zero;
  unsigned char ipproto;
  unsigned short length;
} __attribute__((__packed__));


struct TcpHeader {
  unsigned short	tcp_sport;	/* source port */
  unsigned short	tcp_dport;	/* destination port */
  unsigned int	tcp_seq;	/* sequence number */
  unsigned int	tcp_ack;	/* acknoledgement number */
  unsigned char		tcp_hl;		/* header length (4 bits) */
  unsigned char		tcp_flags;	/* flags */
  unsigned short	tcp_win;	/* advertized window size */
  unsigned short	tcp_xsum;	/* checksum */
  unsigned short	tcp_urp;	/* urgent pointer */
};

struct UdpHeader {
  unsigned short sourcePort;
  unsigned short destPort;
  unsigned short length;
  unsigned short checksum;
};

#endif /* defined(__headers_h__) */
