#include "bbemu.h"

/* Pass-through policy
   This policy does nothing. Thus, the application instance sees the full bandwidth
   and characteristics of the node's own network link. */

PassThroughPolicy::PassThroughPolicy(Controller *controller, int instance, ParameterFile *params) : Policy(controller, instance)
{
}

void PassThroughPolicy::upstreamPacket(int toInstance, unsigned char *data, int size)
{
  myController->tunnelPacket(myInstance, toInstance, data, size);
}

void PassThroughPolicy::downstreamPacket(int fromInstance, unsigned char *data, int size)
{
  myController->deliverPacket(fromInstance, myInstance, data, size);
}
